#ifndef __PARSER_H
#define __PARSER_H

#include "terminals.H"

//TODO - use an array of VECs, this is a little memory not efficient
Tuple& VEC(double a, double b);
#define IF(d, a, b) (d) ? (a) : (b)
#define LT(a, b) (a) < (b) ? true : false
#define EPSILON 0.0000000001f
#define SGN(a) (a) > EPSILON ? (double)(1.0) : (a) < -EPSILON ? (double)(-1.0) : (double)(0.0)
#define ABS(a) (a) > 0 ? (a) : -(a)
Tuple& MIN(Tuple& a, Tuple& b);
double MIN(double a, double b);
Tuple& MAX(Tuple& a, Tuple& b);
double MAX(double a, double b);

Tuple& ADD(Tuple& a, Tuple& b);
double ADD(double a, double b);
bool ADD(bool a, bool b);
Tuple& SUB(Tuple& a, Tuple& b);
double SUB(double a, double b);
Tuple& MUL(double a, Tuple& b);
double MUL(double a, double b);
bool MUL(bool a, bool b);
double OPP(double a);
Tuple& OPP(Tuple& a);
bool OPP(bool a);
double LEN(Tuple& a);
Tuple& NOR(Tuple& a);
Tuple& ROT(double a, Tuple& b);
Tuple& RIG(Tuple& b);
Tuple& LEF(Tuple& b);

#endif
