#ifndef __PRINT_INFO_H
#define __PRINT_INFO_H

#include "GameStateModule.H"
#include "Game.H"
#include "ServerObjData.H"

#define P(x) ((x) != NULL ? *(x) : 0)

// name obj_id code hp max_hp curr_action_id
void print_generic_info(GameObj* gob);
// x, y, size, speed, max_speed, sight, is_moving
void print_moving_info( GameObj* gob);


// min_range, max_range, min_damage, max_damage, cooldown
void print_weapon_info(ScriptObj* weapon);

void print_marine_info(GameObj* gob);
void print_tank_info(GameObj* gob);


void print_unit_info(GameObj* gob);


void print_gob_info(GameObj* gob);
      


#endif
